 // FilterBar.vue

  <template>
    <div class="" style="margin-top: 5px;width:400px" >
                      <vue-autosuggest v-model="query" ref="autoval" :class="['w-100 position-relative', isLoading ?'kt-spinner kt-spinner--sm kt-spinner--danger kt-spinner--right kt-spinner--input' : '']"
    :suggestions="filteredOptions"
      :get-suggestion-value="getSuggestionValue"
    :should-render-suggestions="shouldRenderSuggestions"
    :input-props="{id:'form-control',class:'form-control', placeholder:'Recherche globale...',type:'text',style:'width:100%;padding-right:30px'}"
    @input="filterInput"
    @selected="onSelected"
    @click="clickHandler">  
     <template slot-scope="{suggestion}">
          <h5 class="d-block text-uppercase mb-1" style="color: #595d6e;">{{suggestion.item.type}}</h5>
          <span class="my-suggestion-item text-capitalize" > {{suggestion.item.title}}</span>
     </template>
     </vue-autosuggest>
    </div>

</template>

<script>
  import { VueAutosuggest } from 'vue-autosuggest';
  import _  from 'lodash';
  export default {
    data () {
      return {
        query: '',
        isLoading:false,
        suggestions:[],
        sectionConfigs: {
                'default': {
                    limit: 6,
                    onSelected: function(item, originalInput) {
                        console.log(item, originalInput, `Selected "${item.item}"`);
                    }
                },
                'Location': {
                    limit: 4,
                    type: "locations",
                    onSelected: function() {
                        console.log("url: " + item.item.url);
                    }
                },
                'voitures': {
                    limit: 4,
                    type: "vehicules",
                    onSelected: function() {
                        console.log("url: " + item.item.url);
                    }
                }
            }
      }
    },
    computed:
    {
          filteredOptions()
          {
                    return [
        { 
          data: this.suggestions.filter(option => {
            return option.title.toLowerCase().indexOf(this.query.toLowerCase()) > -1;
          })
        }
      ];
          }
    },
    methods: {
      doFilter () {

        //this.$events.fire('filter-set', this.query)

      },
      resetFilter () {
      this.query = ''  // clear the text in text input
      //this.$events.fire('filter-reset')
      },
        
        shouldRenderSuggestions (size, loading) {
        // This is the default behavior
        return size > 0 && loading ==false
        },
              filterInput(e){
                  
        this.getData()

    },
    getData()
    {
        this.isLoading = true
        axios.get("/api/recherche/?q="+this.query).then((response) => 
        { 
            
            this.suggestions = response.data;
            this.isLoading = false


        },
        (error) =>
        {
            this.suggestions = []
        });
    },
              clickHandler(item) {
      // event fired when clicking on the input
    },
    onSelected(item) {
     var item = item.item
     if(item.type=="vehicules")
     {
                  console.log(this.$route.path, "/voitures/"+item.searchable.id,item.id)

       if (this.$route.path !== "/voitures/"+item.searchable.id)
       this.$router.replace("/voitures/"+item.searchable.id)
       else
       {
           
       }

     }
     if(item.type=="locations")
     {
         console.log(this.$route.path, "/locations/"+item.searchable.id)
         if (this.$route.path !== "/locations/"+item.searchable.id)
         this.$router.push({ name: 'ShowLocation', params: { id: item.searchable.id } })
     }
     this.query = ""
     this.suggestions = []
    },
    onInputChange(text) {
      // event fired when the input changes
    },
    getSuggestionValue(suggestion) {
      return suggestion.item.title;
    },
    focusMe(e) {
      console.log(e) // FocusEvent
    } 
    },
    components:{
      VueAutosuggest
    },
    watch:
    {
            query:_.debounce(function ()
             {
                if(isDefined(this.query))
                {
                  this.doFilter()
                }
                else
                {
                    this.suggestions = []
                }
                
            }, 500)
    }
  }
</script>
<style>
    .autosuggest__results
    {
        BORDer: solid 1px #ccccccad;
    }
.autosuggest__results ul {
  width: 100%;
  color: rgba(30, 39, 46,1.0);
  list-style: none;
  margin: 0;
  padding: 0.5rem 0 .5rem 0;
}
.autosuggest__results ul {
  padding-top:0px;
  padding-bottom:0px;
}
.autosuggest__results li {
    margin: 0 0 0 0;
    padding: 0.75rem 0 0.75rem 0.75rem;
    display: -webkit-box;
    display: flex;
    -webkit-box-align: start;
    align-items: start;
    flex-direction: column;
    border-bottom-style: solid;
    border-bottom-width: 1px;
    border-bottom-color: #9a9a9aa8;
}

.autosuggest__results li:last-child {

    border-bottom-style: none;
    border-bottom-width: 0px;
    border-bottom-color: transparent;
}
.autosuggest__results li:hover {
  cursor: pointer;
}

.autosuggest-container {
  display: flex;
  justify-content: center;
  width: 280px;
}
.autosuggest__results
{
    position: absolute;
    z-index: 100;
    width: 100%;
    background-color: white;
    top:40px;
}

#autosuggest { width: 100%; display: block;}
.autosuggest__results-item--highlighted {
  background-color: #737373;
  color:white !important;
}
.autosuggest__results-item--highlighted h5 {
  
  color:white !important;
}
.spiner.kt-spinner--input.kt-spinner--right:before {
    left: auto;
    right: 1rem;
    left: auto !important;
    right: 1.5rem !important;
}

.kt-spinner.kt-spinner--sm.kt-spinner--right:before {
    left: auto;
    right: 10px;
}
.kt-spinner.kt-spinner--success:before {
    border: 2px solid #1dc9b7;
    border-right: 2px solid transparent;
}
.kt-spinner.kt-spinner--sm:before {
    width: 16px;
    height: 16px;
    margin-top: -8px;
}

.kt-spinner:before {
    -webkit-animation: kt-spinner .5s linear infinite;
    animation: kt-spinner .5s linear infinite;
}
.kt-spinner:before {
    width: 20px;
    height: 20px;
    margin-top: -10px;
}
.kt-spinner:before {
    content: '';
    -webkit-box-sizing: border-box;
    box-sizing: border-box;
    position: absolute;
    top: 50%;
    left: 0;
    border-radius: 50%;
}
</style>